"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1ListClusterOperationsCommand = exports.deserializeAws_restJson1GetCompatibleKafkaVersionsCommand = exports.deserializeAws_restJson1GetBootstrapBrokersCommand = exports.deserializeAws_restJson1DescribeConfigurationRevisionCommand = exports.deserializeAws_restJson1DescribeConfigurationCommand = exports.deserializeAws_restJson1DescribeClusterV2Command = exports.deserializeAws_restJson1DescribeClusterOperationCommand = exports.deserializeAws_restJson1DescribeClusterCommand = exports.deserializeAws_restJson1DeleteConfigurationCommand = exports.deserializeAws_restJson1DeleteClusterCommand = exports.deserializeAws_restJson1CreateConfigurationCommand = exports.deserializeAws_restJson1CreateClusterV2Command = exports.deserializeAws_restJson1CreateClusterCommand = exports.deserializeAws_restJson1BatchDisassociateScramSecretCommand = exports.deserializeAws_restJson1BatchAssociateScramSecretCommand = exports.serializeAws_restJson1UpdateSecurityCommand = exports.serializeAws_restJson1UpdateMonitoringCommand = exports.serializeAws_restJson1UpdateConnectivityCommand = exports.serializeAws_restJson1UpdateConfigurationCommand = exports.serializeAws_restJson1UpdateClusterKafkaVersionCommand = exports.serializeAws_restJson1UpdateClusterConfigurationCommand = exports.serializeAws_restJson1UpdateBrokerTypeCommand = exports.serializeAws_restJson1UpdateBrokerStorageCommand = exports.serializeAws_restJson1UpdateBrokerCountCommand = exports.serializeAws_restJson1UntagResourceCommand = exports.serializeAws_restJson1TagResourceCommand = exports.serializeAws_restJson1RebootBrokerCommand = exports.serializeAws_restJson1ListTagsForResourceCommand = exports.serializeAws_restJson1ListScramSecretsCommand = exports.serializeAws_restJson1ListNodesCommand = exports.serializeAws_restJson1ListKafkaVersionsCommand = exports.serializeAws_restJson1ListConfigurationsCommand = exports.serializeAws_restJson1ListConfigurationRevisionsCommand = exports.serializeAws_restJson1ListClustersV2Command = exports.serializeAws_restJson1ListClustersCommand = exports.serializeAws_restJson1ListClusterOperationsCommand = exports.serializeAws_restJson1GetCompatibleKafkaVersionsCommand = exports.serializeAws_restJson1GetBootstrapBrokersCommand = exports.serializeAws_restJson1DescribeConfigurationRevisionCommand = exports.serializeAws_restJson1DescribeConfigurationCommand = exports.serializeAws_restJson1DescribeClusterV2Command = exports.serializeAws_restJson1DescribeClusterOperationCommand = exports.serializeAws_restJson1DescribeClusterCommand = exports.serializeAws_restJson1DeleteConfigurationCommand = exports.serializeAws_restJson1DeleteClusterCommand = exports.serializeAws_restJson1CreateConfigurationCommand = exports.serializeAws_restJson1CreateClusterV2Command = exports.serializeAws_restJson1CreateClusterCommand = exports.serializeAws_restJson1BatchDisassociateScramSecretCommand = exports.serializeAws_restJson1BatchAssociateScramSecretCommand = void 0;
exports.deserializeAws_restJson1UpdateSecurityCommand = exports.deserializeAws_restJson1UpdateMonitoringCommand = exports.deserializeAws_restJson1UpdateConnectivityCommand = exports.deserializeAws_restJson1UpdateConfigurationCommand = exports.deserializeAws_restJson1UpdateClusterKafkaVersionCommand = exports.deserializeAws_restJson1UpdateClusterConfigurationCommand = exports.deserializeAws_restJson1UpdateBrokerTypeCommand = exports.deserializeAws_restJson1UpdateBrokerStorageCommand = exports.deserializeAws_restJson1UpdateBrokerCountCommand = exports.deserializeAws_restJson1UntagResourceCommand = exports.deserializeAws_restJson1TagResourceCommand = exports.deserializeAws_restJson1RebootBrokerCommand = exports.deserializeAws_restJson1ListTagsForResourceCommand = exports.deserializeAws_restJson1ListScramSecretsCommand = exports.deserializeAws_restJson1ListNodesCommand = exports.deserializeAws_restJson1ListKafkaVersionsCommand = exports.deserializeAws_restJson1ListConfigurationsCommand = exports.deserializeAws_restJson1ListConfigurationRevisionsCommand = exports.deserializeAws_restJson1ListClustersV2Command = exports.deserializeAws_restJson1ListClustersCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const KafkaServiceException_1 = require("../models/KafkaServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_restJson1BatchAssociateScramSecretCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/scram-secrets";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.SecretArnList !== undefined &&
            input.SecretArnList !== null && {
            secretArnList: serializeAws_restJson1__listOf__string(input.SecretArnList, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchAssociateScramSecretCommand = serializeAws_restJson1BatchAssociateScramSecretCommand;
const serializeAws_restJson1BatchDisassociateScramSecretCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/scram-secrets";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.SecretArnList !== undefined &&
            input.SecretArnList !== null && {
            secretArnList: serializeAws_restJson1__listOf__string(input.SecretArnList, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PATCH",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchDisassociateScramSecretCommand = serializeAws_restJson1BatchDisassociateScramSecretCommand;
const serializeAws_restJson1CreateClusterCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters";
    let body;
    body = JSON.stringify({
        ...(input.BrokerNodeGroupInfo !== undefined &&
            input.BrokerNodeGroupInfo !== null && {
            brokerNodeGroupInfo: serializeAws_restJson1BrokerNodeGroupInfo(input.BrokerNodeGroupInfo, context),
        }),
        ...(input.ClientAuthentication !== undefined &&
            input.ClientAuthentication !== null && {
            clientAuthentication: serializeAws_restJson1ClientAuthentication(input.ClientAuthentication, context),
        }),
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { clusterName: input.ClusterName }),
        ...(input.ConfigurationInfo !== undefined &&
            input.ConfigurationInfo !== null && {
            configurationInfo: serializeAws_restJson1ConfigurationInfo(input.ConfigurationInfo, context),
        }),
        ...(input.EncryptionInfo !== undefined &&
            input.EncryptionInfo !== null && {
            encryptionInfo: serializeAws_restJson1EncryptionInfo(input.EncryptionInfo, context),
        }),
        ...(input.EnhancedMonitoring !== undefined &&
            input.EnhancedMonitoring !== null && { enhancedMonitoring: input.EnhancedMonitoring }),
        ...(input.KafkaVersion !== undefined && input.KafkaVersion !== null && { kafkaVersion: input.KafkaVersion }),
        ...(input.LoggingInfo !== undefined &&
            input.LoggingInfo !== null && { loggingInfo: serializeAws_restJson1LoggingInfo(input.LoggingInfo, context) }),
        ...(input.NumberOfBrokerNodes !== undefined &&
            input.NumberOfBrokerNodes !== null && { numberOfBrokerNodes: input.NumberOfBrokerNodes }),
        ...(input.OpenMonitoring !== undefined &&
            input.OpenMonitoring !== null && {
            openMonitoring: serializeAws_restJson1OpenMonitoringInfo(input.OpenMonitoring, context),
        }),
        ...(input.Tags !== undefined &&
            input.Tags !== null && { tags: serializeAws_restJson1__mapOf__string(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateClusterCommand = serializeAws_restJson1CreateClusterCommand;
const serializeAws_restJson1CreateClusterV2Command = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/api/v2/clusters";
    let body;
    body = JSON.stringify({
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { clusterName: input.ClusterName }),
        ...(input.Provisioned !== undefined &&
            input.Provisioned !== null && {
            provisioned: serializeAws_restJson1ProvisionedRequest(input.Provisioned, context),
        }),
        ...(input.Serverless !== undefined &&
            input.Serverless !== null && { serverless: serializeAws_restJson1ServerlessRequest(input.Serverless, context) }),
        ...(input.Tags !== undefined &&
            input.Tags !== null && { tags: serializeAws_restJson1__mapOf__string(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateClusterV2Command = serializeAws_restJson1CreateClusterV2Command;
const serializeAws_restJson1CreateConfigurationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/configurations";
    let body;
    body = JSON.stringify({
        ...(input.Description !== undefined && input.Description !== null && { description: input.Description }),
        ...(input.KafkaVersions !== undefined &&
            input.KafkaVersions !== null && {
            kafkaVersions: serializeAws_restJson1__listOf__string(input.KafkaVersions, context),
        }),
        ...(input.Name !== undefined && input.Name !== null && { name: input.Name }),
        ...(input.ServerProperties !== undefined &&
            input.ServerProperties !== null && { serverProperties: context.base64Encoder(input.ServerProperties) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateConfigurationCommand = serializeAws_restJson1CreateConfigurationCommand;
const serializeAws_restJson1DeleteClusterCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    const query = {
        ...(input.CurrentVersion !== undefined && { currentVersion: input.CurrentVersion }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DeleteClusterCommand = serializeAws_restJson1DeleteClusterCommand;
const serializeAws_restJson1DeleteConfigurationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/configurations/{Arn}";
    if (input.Arn !== undefined) {
        const labelValue = input.Arn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Arn.");
        }
        resolvedPath = resolvedPath.replace("{Arn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Arn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteConfigurationCommand = serializeAws_restJson1DeleteConfigurationCommand;
const serializeAws_restJson1DescribeClusterCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeClusterCommand = serializeAws_restJson1DescribeClusterCommand;
const serializeAws_restJson1DescribeClusterOperationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/operations/{ClusterOperationArn}";
    if (input.ClusterOperationArn !== undefined) {
        const labelValue = input.ClusterOperationArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterOperationArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterOperationArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterOperationArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeClusterOperationCommand = serializeAws_restJson1DescribeClusterOperationCommand;
const serializeAws_restJson1DescribeClusterV2Command = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/api/v2/clusters/{ClusterArn}";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeClusterV2Command = serializeAws_restJson1DescribeClusterV2Command;
const serializeAws_restJson1DescribeConfigurationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/configurations/{Arn}";
    if (input.Arn !== undefined) {
        const labelValue = input.Arn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Arn.");
        }
        resolvedPath = resolvedPath.replace("{Arn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Arn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeConfigurationCommand = serializeAws_restJson1DescribeConfigurationCommand;
const serializeAws_restJson1DescribeConfigurationRevisionCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/v1/configurations/{Arn}/revisions/{Revision}";
    if (input.Arn !== undefined) {
        const labelValue = input.Arn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Arn.");
        }
        resolvedPath = resolvedPath.replace("{Arn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Arn.");
    }
    if (input.Revision !== undefined) {
        const labelValue = input.Revision.toString();
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Revision.");
        }
        resolvedPath = resolvedPath.replace("{Revision}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Revision.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeConfigurationRevisionCommand = serializeAws_restJson1DescribeConfigurationRevisionCommand;
const serializeAws_restJson1GetBootstrapBrokersCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/v1/clusters/{ClusterArn}/bootstrap-brokers";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1GetBootstrapBrokersCommand = serializeAws_restJson1GetBootstrapBrokersCommand;
const serializeAws_restJson1GetCompatibleKafkaVersionsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/compatible-kafka-versions";
    const query = {
        ...(input.ClusterArn !== undefined && { clusterArn: input.ClusterArn }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1GetCompatibleKafkaVersionsCommand = serializeAws_restJson1GetCompatibleKafkaVersionsCommand;
const serializeAws_restJson1ListClusterOperationsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/operations";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListClusterOperationsCommand = serializeAws_restJson1ListClusterOperationsCommand;
const serializeAws_restJson1ListClustersCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters";
    const query = {
        ...(input.ClusterNameFilter !== undefined && { clusterNameFilter: input.ClusterNameFilter }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListClustersCommand = serializeAws_restJson1ListClustersCommand;
const serializeAws_restJson1ListClustersV2Command = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/api/v2/clusters";
    const query = {
        ...(input.ClusterNameFilter !== undefined && { clusterNameFilter: input.ClusterNameFilter }),
        ...(input.ClusterTypeFilter !== undefined && { clusterTypeFilter: input.ClusterTypeFilter }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListClustersV2Command = serializeAws_restJson1ListClustersV2Command;
const serializeAws_restJson1ListConfigurationRevisionsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/configurations/{Arn}/revisions";
    if (input.Arn !== undefined) {
        const labelValue = input.Arn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Arn.");
        }
        resolvedPath = resolvedPath.replace("{Arn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Arn.");
    }
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListConfigurationRevisionsCommand = serializeAws_restJson1ListConfigurationRevisionsCommand;
const serializeAws_restJson1ListConfigurationsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/configurations";
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListConfigurationsCommand = serializeAws_restJson1ListConfigurationsCommand;
const serializeAws_restJson1ListKafkaVersionsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/kafka-versions";
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListKafkaVersionsCommand = serializeAws_restJson1ListKafkaVersionsCommand;
const serializeAws_restJson1ListNodesCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/nodes";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListNodesCommand = serializeAws_restJson1ListNodesCommand;
const serializeAws_restJson1ListScramSecretsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/scram-secrets";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListScramSecretsCommand = serializeAws_restJson1ListScramSecretsCommand;
const serializeAws_restJson1ListTagsForResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListTagsForResourceCommand = serializeAws_restJson1ListTagsForResourceCommand;
const serializeAws_restJson1RebootBrokerCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/reboot-broker";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.BrokerIds !== undefined &&
            input.BrokerIds !== null && { brokerIds: serializeAws_restJson1__listOf__string(input.BrokerIds, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1RebootBrokerCommand = serializeAws_restJson1RebootBrokerCommand;
const serializeAws_restJson1TagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Tags !== undefined &&
            input.Tags !== null && { tags: serializeAws_restJson1__mapOf__string(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1TagResourceCommand = serializeAws_restJson1TagResourceCommand;
const serializeAws_restJson1UntagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    const query = {
        ...(input.TagKeys !== undefined && { tagKeys: (input.TagKeys || []).map((_entry) => _entry) }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1UntagResourceCommand = serializeAws_restJson1UntagResourceCommand;
const serializeAws_restJson1UpdateBrokerCountCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/nodes/count";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
        ...(input.TargetNumberOfBrokerNodes !== undefined &&
            input.TargetNumberOfBrokerNodes !== null && { targetNumberOfBrokerNodes: input.TargetNumberOfBrokerNodes }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateBrokerCountCommand = serializeAws_restJson1UpdateBrokerCountCommand;
const serializeAws_restJson1UpdateBrokerStorageCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/nodes/storage";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
        ...(input.TargetBrokerEBSVolumeInfo !== undefined &&
            input.TargetBrokerEBSVolumeInfo !== null && {
            targetBrokerEBSVolumeInfo: serializeAws_restJson1__listOfBrokerEBSVolumeInfo(input.TargetBrokerEBSVolumeInfo, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateBrokerStorageCommand = serializeAws_restJson1UpdateBrokerStorageCommand;
const serializeAws_restJson1UpdateBrokerTypeCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/nodes/type";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
        ...(input.TargetInstanceType !== undefined &&
            input.TargetInstanceType !== null && { targetInstanceType: input.TargetInstanceType }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateBrokerTypeCommand = serializeAws_restJson1UpdateBrokerTypeCommand;
const serializeAws_restJson1UpdateClusterConfigurationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/configuration";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.ConfigurationInfo !== undefined &&
            input.ConfigurationInfo !== null && {
            configurationInfo: serializeAws_restJson1ConfigurationInfo(input.ConfigurationInfo, context),
        }),
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateClusterConfigurationCommand = serializeAws_restJson1UpdateClusterConfigurationCommand;
const serializeAws_restJson1UpdateClusterKafkaVersionCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/version";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.ConfigurationInfo !== undefined &&
            input.ConfigurationInfo !== null && {
            configurationInfo: serializeAws_restJson1ConfigurationInfo(input.ConfigurationInfo, context),
        }),
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
        ...(input.TargetKafkaVersion !== undefined &&
            input.TargetKafkaVersion !== null && { targetKafkaVersion: input.TargetKafkaVersion }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateClusterKafkaVersionCommand = serializeAws_restJson1UpdateClusterKafkaVersionCommand;
const serializeAws_restJson1UpdateConfigurationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/configurations/{Arn}";
    if (input.Arn !== undefined) {
        const labelValue = input.Arn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Arn.");
        }
        resolvedPath = resolvedPath.replace("{Arn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Arn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Description !== undefined && input.Description !== null && { description: input.Description }),
        ...(input.ServerProperties !== undefined &&
            input.ServerProperties !== null && { serverProperties: context.base64Encoder(input.ServerProperties) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateConfigurationCommand = serializeAws_restJson1UpdateConfigurationCommand;
const serializeAws_restJson1UpdateConnectivityCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/connectivity";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.ConnectivityInfo !== undefined &&
            input.ConnectivityInfo !== null && {
            connectivityInfo: serializeAws_restJson1ConnectivityInfo(input.ConnectivityInfo, context),
        }),
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateConnectivityCommand = serializeAws_restJson1UpdateConnectivityCommand;
const serializeAws_restJson1UpdateMonitoringCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/monitoring";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
        ...(input.EnhancedMonitoring !== undefined &&
            input.EnhancedMonitoring !== null && { enhancedMonitoring: input.EnhancedMonitoring }),
        ...(input.LoggingInfo !== undefined &&
            input.LoggingInfo !== null && { loggingInfo: serializeAws_restJson1LoggingInfo(input.LoggingInfo, context) }),
        ...(input.OpenMonitoring !== undefined &&
            input.OpenMonitoring !== null && {
            openMonitoring: serializeAws_restJson1OpenMonitoringInfo(input.OpenMonitoring, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateMonitoringCommand = serializeAws_restJson1UpdateMonitoringCommand;
const serializeAws_restJson1UpdateSecurityCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/v1/clusters/{ClusterArn}/security";
    if (input.ClusterArn !== undefined) {
        const labelValue = input.ClusterArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ClusterArn.");
        }
        resolvedPath = resolvedPath.replace("{ClusterArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ClusterArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.ClientAuthentication !== undefined &&
            input.ClientAuthentication !== null && {
            clientAuthentication: serializeAws_restJson1ClientAuthentication(input.ClientAuthentication, context),
        }),
        ...(input.CurrentVersion !== undefined &&
            input.CurrentVersion !== null && { currentVersion: input.CurrentVersion }),
        ...(input.EncryptionInfo !== undefined &&
            input.EncryptionInfo !== null && {
            encryptionInfo: serializeAws_restJson1EncryptionInfo(input.EncryptionInfo, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PATCH",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateSecurityCommand = serializeAws_restJson1UpdateSecurityCommand;
const deserializeAws_restJson1BatchAssociateScramSecretCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchAssociateScramSecretCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        UnprocessedScramSecrets: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.unprocessedScramSecrets !== undefined && data.unprocessedScramSecrets !== null) {
        contents.UnprocessedScramSecrets = deserializeAws_restJson1__listOfUnprocessedScramSecret(data.unprocessedScramSecrets, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchAssociateScramSecretCommand = deserializeAws_restJson1BatchAssociateScramSecretCommand;
const deserializeAws_restJson1BatchAssociateScramSecretCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchDisassociateScramSecretCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchDisassociateScramSecretCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        UnprocessedScramSecrets: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.unprocessedScramSecrets !== undefined && data.unprocessedScramSecrets !== null) {
        contents.UnprocessedScramSecrets = deserializeAws_restJson1__listOfUnprocessedScramSecret(data.unprocessedScramSecrets, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchDisassociateScramSecretCommand = deserializeAws_restJson1BatchDisassociateScramSecretCommand;
const deserializeAws_restJson1BatchDisassociateScramSecretCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateClusterCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateClusterCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterName: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterName !== undefined && data.clusterName !== null) {
        contents.ClusterName = (0, smithy_client_1.expectString)(data.clusterName);
    }
    if (data.state !== undefined && data.state !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.state);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateClusterCommand = deserializeAws_restJson1CreateClusterCommand;
const deserializeAws_restJson1CreateClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.kafka#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateClusterV2Command = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateClusterV2CommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterName: undefined,
        ClusterType: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterName !== undefined && data.clusterName !== null) {
        contents.ClusterName = (0, smithy_client_1.expectString)(data.clusterName);
    }
    if (data.clusterType !== undefined && data.clusterType !== null) {
        contents.ClusterType = (0, smithy_client_1.expectString)(data.clusterType);
    }
    if (data.state !== undefined && data.state !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.state);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateClusterV2Command = deserializeAws_restJson1CreateClusterV2Command;
const deserializeAws_restJson1CreateClusterV2CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.kafka#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateConfigurationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        CreationTime: undefined,
        LatestRevision: undefined,
        Name: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.creationTime !== undefined && data.creationTime !== null) {
        contents.CreationTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(data.creationTime));
    }
    if (data.latestRevision !== undefined && data.latestRevision !== null) {
        contents.LatestRevision = deserializeAws_restJson1ConfigurationRevision(data.latestRevision, context);
    }
    if (data.name !== undefined && data.name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.name);
    }
    if (data.state !== undefined && data.state !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.state);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateConfigurationCommand = deserializeAws_restJson1CreateConfigurationCommand;
const deserializeAws_restJson1CreateConfigurationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.kafka#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteClusterCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteClusterCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.state !== undefined && data.state !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.state);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteClusterCommand = deserializeAws_restJson1DeleteClusterCommand;
const deserializeAws_restJson1DeleteClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteConfigurationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.state !== undefined && data.state !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.state);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteConfigurationCommand = deserializeAws_restJson1DeleteConfigurationCommand;
const deserializeAws_restJson1DeleteConfigurationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeClusterCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeClusterCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterInfo: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterInfo !== undefined && data.clusterInfo !== null) {
        contents.ClusterInfo = deserializeAws_restJson1ClusterInfo(data.clusterInfo, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeClusterCommand = deserializeAws_restJson1DescribeClusterCommand;
const deserializeAws_restJson1DescribeClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeClusterOperationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeClusterOperationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterOperationInfo: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterOperationInfo !== undefined && data.clusterOperationInfo !== null) {
        contents.ClusterOperationInfo = deserializeAws_restJson1ClusterOperationInfo(data.clusterOperationInfo, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeClusterOperationCommand = deserializeAws_restJson1DescribeClusterOperationCommand;
const deserializeAws_restJson1DescribeClusterOperationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeClusterV2Command = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeClusterV2CommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterInfo: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterInfo !== undefined && data.clusterInfo !== null) {
        contents.ClusterInfo = deserializeAws_restJson1Cluster(data.clusterInfo, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeClusterV2Command = deserializeAws_restJson1DescribeClusterV2Command;
const deserializeAws_restJson1DescribeClusterV2CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeConfigurationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        CreationTime: undefined,
        Description: undefined,
        KafkaVersions: undefined,
        LatestRevision: undefined,
        Name: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.creationTime !== undefined && data.creationTime !== null) {
        contents.CreationTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(data.creationTime));
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.kafkaVersions !== undefined && data.kafkaVersions !== null) {
        contents.KafkaVersions = deserializeAws_restJson1__listOf__string(data.kafkaVersions, context);
    }
    if (data.latestRevision !== undefined && data.latestRevision !== null) {
        contents.LatestRevision = deserializeAws_restJson1ConfigurationRevision(data.latestRevision, context);
    }
    if (data.name !== undefined && data.name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.name);
    }
    if (data.state !== undefined && data.state !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.state);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeConfigurationCommand = deserializeAws_restJson1DescribeConfigurationCommand;
const deserializeAws_restJson1DescribeConfigurationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeConfigurationRevisionCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeConfigurationRevisionCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        CreationTime: undefined,
        Description: undefined,
        Revision: undefined,
        ServerProperties: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.creationTime !== undefined && data.creationTime !== null) {
        contents.CreationTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(data.creationTime));
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.revision !== undefined && data.revision !== null) {
        contents.Revision = (0, smithy_client_1.expectLong)(data.revision);
    }
    if (data.serverProperties !== undefined && data.serverProperties !== null) {
        contents.ServerProperties = context.base64Decoder(data.serverProperties);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeConfigurationRevisionCommand = deserializeAws_restJson1DescribeConfigurationRevisionCommand;
const deserializeAws_restJson1DescribeConfigurationRevisionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetBootstrapBrokersCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetBootstrapBrokersCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        BootstrapBrokerString: undefined,
        BootstrapBrokerStringPublicSaslIam: undefined,
        BootstrapBrokerStringPublicSaslScram: undefined,
        BootstrapBrokerStringPublicTls: undefined,
        BootstrapBrokerStringSaslIam: undefined,
        BootstrapBrokerStringSaslScram: undefined,
        BootstrapBrokerStringTls: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.bootstrapBrokerString !== undefined && data.bootstrapBrokerString !== null) {
        contents.BootstrapBrokerString = (0, smithy_client_1.expectString)(data.bootstrapBrokerString);
    }
    if (data.bootstrapBrokerStringPublicSaslIam !== undefined && data.bootstrapBrokerStringPublicSaslIam !== null) {
        contents.BootstrapBrokerStringPublicSaslIam = (0, smithy_client_1.expectString)(data.bootstrapBrokerStringPublicSaslIam);
    }
    if (data.bootstrapBrokerStringPublicSaslScram !== undefined && data.bootstrapBrokerStringPublicSaslScram !== null) {
        contents.BootstrapBrokerStringPublicSaslScram = (0, smithy_client_1.expectString)(data.bootstrapBrokerStringPublicSaslScram);
    }
    if (data.bootstrapBrokerStringPublicTls !== undefined && data.bootstrapBrokerStringPublicTls !== null) {
        contents.BootstrapBrokerStringPublicTls = (0, smithy_client_1.expectString)(data.bootstrapBrokerStringPublicTls);
    }
    if (data.bootstrapBrokerStringSaslIam !== undefined && data.bootstrapBrokerStringSaslIam !== null) {
        contents.BootstrapBrokerStringSaslIam = (0, smithy_client_1.expectString)(data.bootstrapBrokerStringSaslIam);
    }
    if (data.bootstrapBrokerStringSaslScram !== undefined && data.bootstrapBrokerStringSaslScram !== null) {
        contents.BootstrapBrokerStringSaslScram = (0, smithy_client_1.expectString)(data.bootstrapBrokerStringSaslScram);
    }
    if (data.bootstrapBrokerStringTls !== undefined && data.bootstrapBrokerStringTls !== null) {
        contents.BootstrapBrokerStringTls = (0, smithy_client_1.expectString)(data.bootstrapBrokerStringTls);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetBootstrapBrokersCommand = deserializeAws_restJson1GetBootstrapBrokersCommand;
const deserializeAws_restJson1GetBootstrapBrokersCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.kafka#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetCompatibleKafkaVersionsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetCompatibleKafkaVersionsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        CompatibleKafkaVersions: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.compatibleKafkaVersions !== undefined && data.compatibleKafkaVersions !== null) {
        contents.CompatibleKafkaVersions = deserializeAws_restJson1__listOfCompatibleKafkaVersion(data.compatibleKafkaVersions, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetCompatibleKafkaVersionsCommand = deserializeAws_restJson1GetCompatibleKafkaVersionsCommand;
const deserializeAws_restJson1GetCompatibleKafkaVersionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListClusterOperationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListClusterOperationsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterOperationInfoList: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterOperationInfoList !== undefined && data.clusterOperationInfoList !== null) {
        contents.ClusterOperationInfoList = deserializeAws_restJson1__listOfClusterOperationInfo(data.clusterOperationInfoList, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListClusterOperationsCommand = deserializeAws_restJson1ListClusterOperationsCommand;
const deserializeAws_restJson1ListClusterOperationsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListClustersCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListClustersCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterInfoList: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterInfoList !== undefined && data.clusterInfoList !== null) {
        contents.ClusterInfoList = deserializeAws_restJson1__listOfClusterInfo(data.clusterInfoList, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListClustersCommand = deserializeAws_restJson1ListClustersCommand;
const deserializeAws_restJson1ListClustersCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListClustersV2Command = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListClustersV2CommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterInfoList: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterInfoList !== undefined && data.clusterInfoList !== null) {
        contents.ClusterInfoList = deserializeAws_restJson1__listOfCluster(data.clusterInfoList, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListClustersV2Command = deserializeAws_restJson1ListClustersV2Command;
const deserializeAws_restJson1ListClustersV2CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListConfigurationRevisionsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListConfigurationRevisionsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        Revisions: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    if (data.revisions !== undefined && data.revisions !== null) {
        contents.Revisions = deserializeAws_restJson1__listOfConfigurationRevision(data.revisions, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListConfigurationRevisionsCommand = deserializeAws_restJson1ListConfigurationRevisionsCommand;
const deserializeAws_restJson1ListConfigurationRevisionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListConfigurationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListConfigurationsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Configurations: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.configurations !== undefined && data.configurations !== null) {
        contents.Configurations = deserializeAws_restJson1__listOfConfiguration(data.configurations, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListConfigurationsCommand = deserializeAws_restJson1ListConfigurationsCommand;
const deserializeAws_restJson1ListConfigurationsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListKafkaVersionsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListKafkaVersionsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        KafkaVersions: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.kafkaVersions !== undefined && data.kafkaVersions !== null) {
        contents.KafkaVersions = deserializeAws_restJson1__listOfKafkaVersion(data.kafkaVersions, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListKafkaVersionsCommand = deserializeAws_restJson1ListKafkaVersionsCommand;
const deserializeAws_restJson1ListKafkaVersionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListNodesCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListNodesCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        NodeInfoList: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    if (data.nodeInfoList !== undefined && data.nodeInfoList !== null) {
        contents.NodeInfoList = deserializeAws_restJson1__listOfNodeInfo(data.nodeInfoList, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListNodesCommand = deserializeAws_restJson1ListNodesCommand;
const deserializeAws_restJson1ListNodesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListScramSecretsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListScramSecretsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        SecretArnList: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    if (data.secretArnList !== undefined && data.secretArnList !== null) {
        contents.SecretArnList = deserializeAws_restJson1__listOf__string(data.secretArnList, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListScramSecretsCommand = deserializeAws_restJson1ListScramSecretsCommand;
const deserializeAws_restJson1ListScramSecretsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListTagsForResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1__mapOf__string(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListTagsForResourceCommand = deserializeAws_restJson1ListTagsForResourceCommand;
const deserializeAws_restJson1ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1RebootBrokerCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1RebootBrokerCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1RebootBrokerCommand = deserializeAws_restJson1RebootBrokerCommand;
const deserializeAws_restJson1RebootBrokerCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return deserializeAws_restJson1TagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1TagResourceCommand = deserializeAws_restJson1TagResourceCommand;
const deserializeAws_restJson1TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return deserializeAws_restJson1UntagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UntagResourceCommand = deserializeAws_restJson1UntagResourceCommand;
const deserializeAws_restJson1UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateBrokerCountCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateBrokerCountCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateBrokerCountCommand = deserializeAws_restJson1UpdateBrokerCountCommand;
const deserializeAws_restJson1UpdateBrokerCountCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateBrokerStorageCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateBrokerStorageCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateBrokerStorageCommand = deserializeAws_restJson1UpdateBrokerStorageCommand;
const deserializeAws_restJson1UpdateBrokerStorageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateBrokerTypeCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateBrokerTypeCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateBrokerTypeCommand = deserializeAws_restJson1UpdateBrokerTypeCommand;
const deserializeAws_restJson1UpdateBrokerTypeCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateClusterConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateClusterConfigurationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateClusterConfigurationCommand = deserializeAws_restJson1UpdateClusterConfigurationCommand;
const deserializeAws_restJson1UpdateClusterConfigurationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateClusterKafkaVersionCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateClusterKafkaVersionCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateClusterKafkaVersionCommand = deserializeAws_restJson1UpdateClusterKafkaVersionCommand;
const deserializeAws_restJson1UpdateClusterKafkaVersionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateConfigurationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateConfigurationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        LatestRevision: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.latestRevision !== undefined && data.latestRevision !== null) {
        contents.LatestRevision = deserializeAws_restJson1ConfigurationRevision(data.latestRevision, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateConfigurationCommand = deserializeAws_restJson1UpdateConfigurationCommand;
const deserializeAws_restJson1UpdateConfigurationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateConnectivityCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateConnectivityCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateConnectivityCommand = deserializeAws_restJson1UpdateConnectivityCommand;
const deserializeAws_restJson1UpdateConnectivityCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateMonitoringCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateMonitoringCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateMonitoringCommand = deserializeAws_restJson1UpdateMonitoringCommand;
const deserializeAws_restJson1UpdateMonitoringCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateSecurityCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateSecurityCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ClusterArn: undefined,
        ClusterOperationArn: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.clusterArn !== undefined && data.clusterArn !== null) {
        contents.ClusterArn = (0, smithy_client_1.expectString)(data.clusterArn);
    }
    if (data.clusterOperationArn !== undefined && data.clusterOperationArn !== null) {
        contents.ClusterOperationArn = (0, smithy_client_1.expectString)(data.clusterOperationArn);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateSecurityCommand = deserializeAws_restJson1UpdateSecurityCommand;
const deserializeAws_restJson1UpdateSecurityCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BadRequestException":
        case "com.amazonaws.kafka#BadRequestException":
            throw await deserializeAws_restJson1BadRequestExceptionResponse(parsedOutput, context);
        case "ForbiddenException":
        case "com.amazonaws.kafka#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.kafka#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.kafka#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.kafka#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.kafka#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnauthorizedException":
        case "com.amazonaws.kafka#UnauthorizedException":
            throw await deserializeAws_restJson1UnauthorizedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new KafkaServiceException_1.KafkaServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BadRequestExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.BadRequestException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ConflictExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ForbiddenExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ForbiddenException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InternalServerErrorExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.InternalServerErrorException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1NotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.NotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ServiceUnavailableExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ServiceUnavailableException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1TooManyRequestsExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.TooManyRequestsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1UnauthorizedExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.invalidParameter !== undefined && data.invalidParameter !== null) {
        contents.InvalidParameter = (0, smithy_client_1.expectString)(data.invalidParameter);
    }
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.UnauthorizedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1__listOf__string = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1__listOfBrokerEBSVolumeInfo = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1BrokerEBSVolumeInfo(entry, context);
    });
};
const serializeAws_restJson1__listOfVpcConfig = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1VpcConfig(entry, context);
    });
};
const serializeAws_restJson1__mapOf__string = (input, context) => {
    return Object.entries(input).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: value,
        };
    }, {});
};
const serializeAws_restJson1BrokerEBSVolumeInfo = (input, context) => {
    return {
        ...(input.KafkaBrokerNodeId !== undefined &&
            input.KafkaBrokerNodeId !== null && { kafkaBrokerNodeId: input.KafkaBrokerNodeId }),
        ...(input.ProvisionedThroughput !== undefined &&
            input.ProvisionedThroughput !== null && {
            provisionedThroughput: serializeAws_restJson1ProvisionedThroughput(input.ProvisionedThroughput, context),
        }),
        ...(input.VolumeSizeGB !== undefined && input.VolumeSizeGB !== null && { volumeSizeGB: input.VolumeSizeGB }),
    };
};
const serializeAws_restJson1BrokerLogs = (input, context) => {
    return {
        ...(input.CloudWatchLogs !== undefined &&
            input.CloudWatchLogs !== null && {
            cloudWatchLogs: serializeAws_restJson1CloudWatchLogs(input.CloudWatchLogs, context),
        }),
        ...(input.Firehose !== undefined &&
            input.Firehose !== null && { firehose: serializeAws_restJson1Firehose(input.Firehose, context) }),
        ...(input.S3 !== undefined && input.S3 !== null && { s3: serializeAws_restJson1S3(input.S3, context) }),
    };
};
const serializeAws_restJson1BrokerNodeGroupInfo = (input, context) => {
    return {
        ...(input.BrokerAZDistribution !== undefined &&
            input.BrokerAZDistribution !== null && { brokerAZDistribution: input.BrokerAZDistribution }),
        ...(input.ClientSubnets !== undefined &&
            input.ClientSubnets !== null && {
            clientSubnets: serializeAws_restJson1__listOf__string(input.ClientSubnets, context),
        }),
        ...(input.ConnectivityInfo !== undefined &&
            input.ConnectivityInfo !== null && {
            connectivityInfo: serializeAws_restJson1ConnectivityInfo(input.ConnectivityInfo, context),
        }),
        ...(input.InstanceType !== undefined && input.InstanceType !== null && { instanceType: input.InstanceType }),
        ...(input.SecurityGroups !== undefined &&
            input.SecurityGroups !== null && {
            securityGroups: serializeAws_restJson1__listOf__string(input.SecurityGroups, context),
        }),
        ...(input.StorageInfo !== undefined &&
            input.StorageInfo !== null && { storageInfo: serializeAws_restJson1StorageInfo(input.StorageInfo, context) }),
    };
};
const serializeAws_restJson1ClientAuthentication = (input, context) => {
    return {
        ...(input.Sasl !== undefined && input.Sasl !== null && { sasl: serializeAws_restJson1Sasl(input.Sasl, context) }),
        ...(input.Tls !== undefined && input.Tls !== null && { tls: serializeAws_restJson1Tls(input.Tls, context) }),
        ...(input.Unauthenticated !== undefined &&
            input.Unauthenticated !== null && {
            unauthenticated: serializeAws_restJson1Unauthenticated(input.Unauthenticated, context),
        }),
    };
};
const serializeAws_restJson1CloudWatchLogs = (input, context) => {
    return {
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
        ...(input.LogGroup !== undefined && input.LogGroup !== null && { logGroup: input.LogGroup }),
    };
};
const serializeAws_restJson1ConfigurationInfo = (input, context) => {
    return {
        ...(input.Arn !== undefined && input.Arn !== null && { arn: input.Arn }),
        ...(input.Revision !== undefined && input.Revision !== null && { revision: input.Revision }),
    };
};
const serializeAws_restJson1ConnectivityInfo = (input, context) => {
    return {
        ...(input.PublicAccess !== undefined &&
            input.PublicAccess !== null && { publicAccess: serializeAws_restJson1PublicAccess(input.PublicAccess, context) }),
    };
};
const serializeAws_restJson1EBSStorageInfo = (input, context) => {
    return {
        ...(input.ProvisionedThroughput !== undefined &&
            input.ProvisionedThroughput !== null && {
            provisionedThroughput: serializeAws_restJson1ProvisionedThroughput(input.ProvisionedThroughput, context),
        }),
        ...(input.VolumeSize !== undefined && input.VolumeSize !== null && { volumeSize: input.VolumeSize }),
    };
};
const serializeAws_restJson1EncryptionAtRest = (input, context) => {
    return {
        ...(input.DataVolumeKMSKeyId !== undefined &&
            input.DataVolumeKMSKeyId !== null && { dataVolumeKMSKeyId: input.DataVolumeKMSKeyId }),
    };
};
const serializeAws_restJson1EncryptionInfo = (input, context) => {
    return {
        ...(input.EncryptionAtRest !== undefined &&
            input.EncryptionAtRest !== null && {
            encryptionAtRest: serializeAws_restJson1EncryptionAtRest(input.EncryptionAtRest, context),
        }),
        ...(input.EncryptionInTransit !== undefined &&
            input.EncryptionInTransit !== null && {
            encryptionInTransit: serializeAws_restJson1EncryptionInTransit(input.EncryptionInTransit, context),
        }),
    };
};
const serializeAws_restJson1EncryptionInTransit = (input, context) => {
    return {
        ...(input.ClientBroker !== undefined && input.ClientBroker !== null && { clientBroker: input.ClientBroker }),
        ...(input.InCluster !== undefined && input.InCluster !== null && { inCluster: input.InCluster }),
    };
};
const serializeAws_restJson1Firehose = (input, context) => {
    return {
        ...(input.DeliveryStream !== undefined &&
            input.DeliveryStream !== null && { deliveryStream: input.DeliveryStream }),
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
    };
};
const serializeAws_restJson1Iam = (input, context) => {
    return {
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
    };
};
const serializeAws_restJson1JmxExporterInfo = (input, context) => {
    return {
        ...(input.EnabledInBroker !== undefined &&
            input.EnabledInBroker !== null && { enabledInBroker: input.EnabledInBroker }),
    };
};
const serializeAws_restJson1LoggingInfo = (input, context) => {
    return {
        ...(input.BrokerLogs !== undefined &&
            input.BrokerLogs !== null && { brokerLogs: serializeAws_restJson1BrokerLogs(input.BrokerLogs, context) }),
    };
};
const serializeAws_restJson1NodeExporterInfo = (input, context) => {
    return {
        ...(input.EnabledInBroker !== undefined &&
            input.EnabledInBroker !== null && { enabledInBroker: input.EnabledInBroker }),
    };
};
const serializeAws_restJson1OpenMonitoringInfo = (input, context) => {
    return {
        ...(input.Prometheus !== undefined &&
            input.Prometheus !== null && { prometheus: serializeAws_restJson1PrometheusInfo(input.Prometheus, context) }),
    };
};
const serializeAws_restJson1PrometheusInfo = (input, context) => {
    return {
        ...(input.JmxExporter !== undefined &&
            input.JmxExporter !== null && { jmxExporter: serializeAws_restJson1JmxExporterInfo(input.JmxExporter, context) }),
        ...(input.NodeExporter !== undefined &&
            input.NodeExporter !== null && {
            nodeExporter: serializeAws_restJson1NodeExporterInfo(input.NodeExporter, context),
        }),
    };
};
const serializeAws_restJson1ProvisionedRequest = (input, context) => {
    return {
        ...(input.BrokerNodeGroupInfo !== undefined &&
            input.BrokerNodeGroupInfo !== null && {
            brokerNodeGroupInfo: serializeAws_restJson1BrokerNodeGroupInfo(input.BrokerNodeGroupInfo, context),
        }),
        ...(input.ClientAuthentication !== undefined &&
            input.ClientAuthentication !== null && {
            clientAuthentication: serializeAws_restJson1ClientAuthentication(input.ClientAuthentication, context),
        }),
        ...(input.ConfigurationInfo !== undefined &&
            input.ConfigurationInfo !== null && {
            configurationInfo: serializeAws_restJson1ConfigurationInfo(input.ConfigurationInfo, context),
        }),
        ...(input.EncryptionInfo !== undefined &&
            input.EncryptionInfo !== null && {
            encryptionInfo: serializeAws_restJson1EncryptionInfo(input.EncryptionInfo, context),
        }),
        ...(input.EnhancedMonitoring !== undefined &&
            input.EnhancedMonitoring !== null && { enhancedMonitoring: input.EnhancedMonitoring }),
        ...(input.KafkaVersion !== undefined && input.KafkaVersion !== null && { kafkaVersion: input.KafkaVersion }),
        ...(input.LoggingInfo !== undefined &&
            input.LoggingInfo !== null && { loggingInfo: serializeAws_restJson1LoggingInfo(input.LoggingInfo, context) }),
        ...(input.NumberOfBrokerNodes !== undefined &&
            input.NumberOfBrokerNodes !== null && { numberOfBrokerNodes: input.NumberOfBrokerNodes }),
        ...(input.OpenMonitoring !== undefined &&
            input.OpenMonitoring !== null && {
            openMonitoring: serializeAws_restJson1OpenMonitoringInfo(input.OpenMonitoring, context),
        }),
    };
};
const serializeAws_restJson1ProvisionedThroughput = (input, context) => {
    return {
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
        ...(input.VolumeThroughput !== undefined &&
            input.VolumeThroughput !== null && { volumeThroughput: input.VolumeThroughput }),
    };
};
const serializeAws_restJson1PublicAccess = (input, context) => {
    return {
        ...(input.Type !== undefined && input.Type !== null && { type: input.Type }),
    };
};
const serializeAws_restJson1S3 = (input, context) => {
    return {
        ...(input.Bucket !== undefined && input.Bucket !== null && { bucket: input.Bucket }),
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
        ...(input.Prefix !== undefined && input.Prefix !== null && { prefix: input.Prefix }),
    };
};
const serializeAws_restJson1Sasl = (input, context) => {
    return {
        ...(input.Iam !== undefined && input.Iam !== null && { iam: serializeAws_restJson1Iam(input.Iam, context) }),
        ...(input.Scram !== undefined &&
            input.Scram !== null && { scram: serializeAws_restJson1Scram(input.Scram, context) }),
    };
};
const serializeAws_restJson1Scram = (input, context) => {
    return {
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
    };
};
const serializeAws_restJson1ServerlessClientAuthentication = (input, context) => {
    return {
        ...(input.Sasl !== undefined &&
            input.Sasl !== null && { sasl: serializeAws_restJson1ServerlessSasl(input.Sasl, context) }),
    };
};
const serializeAws_restJson1ServerlessRequest = (input, context) => {
    return {
        ...(input.ClientAuthentication !== undefined &&
            input.ClientAuthentication !== null && {
            clientAuthentication: serializeAws_restJson1ServerlessClientAuthentication(input.ClientAuthentication, context),
        }),
        ...(input.VpcConfigs !== undefined &&
            input.VpcConfigs !== null && { vpcConfigs: serializeAws_restJson1__listOfVpcConfig(input.VpcConfigs, context) }),
    };
};
const serializeAws_restJson1ServerlessSasl = (input, context) => {
    return {
        ...(input.Iam !== undefined && input.Iam !== null && { iam: serializeAws_restJson1Iam(input.Iam, context) }),
    };
};
const serializeAws_restJson1StorageInfo = (input, context) => {
    return {
        ...(input.EbsStorageInfo !== undefined &&
            input.EbsStorageInfo !== null && {
            ebsStorageInfo: serializeAws_restJson1EBSStorageInfo(input.EbsStorageInfo, context),
        }),
    };
};
const serializeAws_restJson1Tls = (input, context) => {
    return {
        ...(input.CertificateAuthorityArnList !== undefined &&
            input.CertificateAuthorityArnList !== null && {
            certificateAuthorityArnList: serializeAws_restJson1__listOf__string(input.CertificateAuthorityArnList, context),
        }),
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
    };
};
const serializeAws_restJson1Unauthenticated = (input, context) => {
    return {
        ...(input.Enabled !== undefined && input.Enabled !== null && { enabled: input.Enabled }),
    };
};
const serializeAws_restJson1VpcConfig = (input, context) => {
    return {
        ...(input.SecurityGroupIds !== undefined &&
            input.SecurityGroupIds !== null && {
            securityGroupIds: serializeAws_restJson1__listOf__string(input.SecurityGroupIds, context),
        }),
        ...(input.SubnetIds !== undefined &&
            input.SubnetIds !== null && { subnetIds: serializeAws_restJson1__listOf__string(input.SubnetIds, context) }),
    };
};
const deserializeAws_restJson1__listOf__string = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfBrokerEBSVolumeInfo = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BrokerEBSVolumeInfo(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfCluster = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Cluster(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfClusterInfo = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ClusterInfo(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfClusterOperationInfo = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ClusterOperationInfo(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfClusterOperationStep = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ClusterOperationStep(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfCompatibleKafkaVersion = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1CompatibleKafkaVersion(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfConfiguration = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Configuration(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfConfigurationRevision = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ConfigurationRevision(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfKafkaVersion = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1KafkaVersion(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfNodeInfo = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1NodeInfo(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfUnprocessedScramSecret = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1UnprocessedScramSecret(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfVpcConfig = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1VpcConfig(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__mapOf__string = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeAws_restJson1BrokerEBSVolumeInfo = (output, context) => {
    return {
        KafkaBrokerNodeId: (0, smithy_client_1.expectString)(output.kafkaBrokerNodeId),
        ProvisionedThroughput: output.provisionedThroughput !== undefined && output.provisionedThroughput !== null
            ? deserializeAws_restJson1ProvisionedThroughput(output.provisionedThroughput, context)
            : undefined,
        VolumeSizeGB: (0, smithy_client_1.expectInt32)(output.volumeSizeGB),
    };
};
const deserializeAws_restJson1BrokerLogs = (output, context) => {
    return {
        CloudWatchLogs: output.cloudWatchLogs !== undefined && output.cloudWatchLogs !== null
            ? deserializeAws_restJson1CloudWatchLogs(output.cloudWatchLogs, context)
            : undefined,
        Firehose: output.firehose !== undefined && output.firehose !== null
            ? deserializeAws_restJson1Firehose(output.firehose, context)
            : undefined,
        S3: output.s3 !== undefined && output.s3 !== null ? deserializeAws_restJson1S3(output.s3, context) : undefined,
    };
};
const deserializeAws_restJson1BrokerNodeGroupInfo = (output, context) => {
    return {
        BrokerAZDistribution: (0, smithy_client_1.expectString)(output.brokerAZDistribution),
        ClientSubnets: output.clientSubnets !== undefined && output.clientSubnets !== null
            ? deserializeAws_restJson1__listOf__string(output.clientSubnets, context)
            : undefined,
        ConnectivityInfo: output.connectivityInfo !== undefined && output.connectivityInfo !== null
            ? deserializeAws_restJson1ConnectivityInfo(output.connectivityInfo, context)
            : undefined,
        InstanceType: (0, smithy_client_1.expectString)(output.instanceType),
        SecurityGroups: output.securityGroups !== undefined && output.securityGroups !== null
            ? deserializeAws_restJson1__listOf__string(output.securityGroups, context)
            : undefined,
        StorageInfo: output.storageInfo !== undefined && output.storageInfo !== null
            ? deserializeAws_restJson1StorageInfo(output.storageInfo, context)
            : undefined,
    };
};
const deserializeAws_restJson1BrokerNodeInfo = (output, context) => {
    return {
        AttachedENIId: (0, smithy_client_1.expectString)(output.attachedENIId),
        BrokerId: (0, smithy_client_1.limitedParseDouble)(output.brokerId),
        ClientSubnet: (0, smithy_client_1.expectString)(output.clientSubnet),
        ClientVpcIpAddress: (0, smithy_client_1.expectString)(output.clientVpcIpAddress),
        CurrentBrokerSoftwareInfo: output.currentBrokerSoftwareInfo !== undefined && output.currentBrokerSoftwareInfo !== null
            ? deserializeAws_restJson1BrokerSoftwareInfo(output.currentBrokerSoftwareInfo, context)
            : undefined,
        Endpoints: output.endpoints !== undefined && output.endpoints !== null
            ? deserializeAws_restJson1__listOf__string(output.endpoints, context)
            : undefined,
    };
};
const deserializeAws_restJson1BrokerSoftwareInfo = (output, context) => {
    return {
        ConfigurationArn: (0, smithy_client_1.expectString)(output.configurationArn),
        ConfigurationRevision: (0, smithy_client_1.expectLong)(output.configurationRevision),
        KafkaVersion: (0, smithy_client_1.expectString)(output.kafkaVersion),
    };
};
const deserializeAws_restJson1ClientAuthentication = (output, context) => {
    return {
        Sasl: output.sasl !== undefined && output.sasl !== null
            ? deserializeAws_restJson1Sasl(output.sasl, context)
            : undefined,
        Tls: output.tls !== undefined && output.tls !== null ? deserializeAws_restJson1Tls(output.tls, context) : undefined,
        Unauthenticated: output.unauthenticated !== undefined && output.unauthenticated !== null
            ? deserializeAws_restJson1Unauthenticated(output.unauthenticated, context)
            : undefined,
    };
};
const deserializeAws_restJson1CloudWatchLogs = (output, context) => {
    return {
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
        LogGroup: (0, smithy_client_1.expectString)(output.logGroup),
    };
};
const deserializeAws_restJson1Cluster = (output, context) => {
    return {
        ActiveOperationArn: (0, smithy_client_1.expectString)(output.activeOperationArn),
        ClusterArn: (0, smithy_client_1.expectString)(output.clusterArn),
        ClusterName: (0, smithy_client_1.expectString)(output.clusterName),
        ClusterType: (0, smithy_client_1.expectString)(output.clusterType),
        CreationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(output.creationTime))
            : undefined,
        CurrentVersion: (0, smithy_client_1.expectString)(output.currentVersion),
        Provisioned: output.provisioned !== undefined && output.provisioned !== null
            ? deserializeAws_restJson1Provisioned(output.provisioned, context)
            : undefined,
        Serverless: output.serverless !== undefined && output.serverless !== null
            ? deserializeAws_restJson1Serverless(output.serverless, context)
            : undefined,
        State: (0, smithy_client_1.expectString)(output.state),
        StateInfo: output.stateInfo !== undefined && output.stateInfo !== null
            ? deserializeAws_restJson1StateInfo(output.stateInfo, context)
            : undefined,
        Tags: output.tags !== undefined && output.tags !== null
            ? deserializeAws_restJson1__mapOf__string(output.tags, context)
            : undefined,
    };
};
const deserializeAws_restJson1ClusterInfo = (output, context) => {
    return {
        ActiveOperationArn: (0, smithy_client_1.expectString)(output.activeOperationArn),
        BrokerNodeGroupInfo: output.brokerNodeGroupInfo !== undefined && output.brokerNodeGroupInfo !== null
            ? deserializeAws_restJson1BrokerNodeGroupInfo(output.brokerNodeGroupInfo, context)
            : undefined,
        ClientAuthentication: output.clientAuthentication !== undefined && output.clientAuthentication !== null
            ? deserializeAws_restJson1ClientAuthentication(output.clientAuthentication, context)
            : undefined,
        ClusterArn: (0, smithy_client_1.expectString)(output.clusterArn),
        ClusterName: (0, smithy_client_1.expectString)(output.clusterName),
        CreationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(output.creationTime))
            : undefined,
        CurrentBrokerSoftwareInfo: output.currentBrokerSoftwareInfo !== undefined && output.currentBrokerSoftwareInfo !== null
            ? deserializeAws_restJson1BrokerSoftwareInfo(output.currentBrokerSoftwareInfo, context)
            : undefined,
        CurrentVersion: (0, smithy_client_1.expectString)(output.currentVersion),
        EncryptionInfo: output.encryptionInfo !== undefined && output.encryptionInfo !== null
            ? deserializeAws_restJson1EncryptionInfo(output.encryptionInfo, context)
            : undefined,
        EnhancedMonitoring: (0, smithy_client_1.expectString)(output.enhancedMonitoring),
        LoggingInfo: output.loggingInfo !== undefined && output.loggingInfo !== null
            ? deserializeAws_restJson1LoggingInfo(output.loggingInfo, context)
            : undefined,
        NumberOfBrokerNodes: (0, smithy_client_1.expectInt32)(output.numberOfBrokerNodes),
        OpenMonitoring: output.openMonitoring !== undefined && output.openMonitoring !== null
            ? deserializeAws_restJson1OpenMonitoring(output.openMonitoring, context)
            : undefined,
        State: (0, smithy_client_1.expectString)(output.state),
        StateInfo: output.stateInfo !== undefined && output.stateInfo !== null
            ? deserializeAws_restJson1StateInfo(output.stateInfo, context)
            : undefined,
        Tags: output.tags !== undefined && output.tags !== null
            ? deserializeAws_restJson1__mapOf__string(output.tags, context)
            : undefined,
        ZookeeperConnectString: (0, smithy_client_1.expectString)(output.zookeeperConnectString),
        ZookeeperConnectStringTls: (0, smithy_client_1.expectString)(output.zookeeperConnectStringTls),
    };
};
const deserializeAws_restJson1ClusterOperationInfo = (output, context) => {
    return {
        ClientRequestId: (0, smithy_client_1.expectString)(output.clientRequestId),
        ClusterArn: (0, smithy_client_1.expectString)(output.clusterArn),
        CreationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(output.creationTime))
            : undefined,
        EndTime: output.endTime !== undefined && output.endTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(output.endTime))
            : undefined,
        ErrorInfo: output.errorInfo !== undefined && output.errorInfo !== null
            ? deserializeAws_restJson1ErrorInfo(output.errorInfo, context)
            : undefined,
        OperationArn: (0, smithy_client_1.expectString)(output.operationArn),
        OperationState: (0, smithy_client_1.expectString)(output.operationState),
        OperationSteps: output.operationSteps !== undefined && output.operationSteps !== null
            ? deserializeAws_restJson1__listOfClusterOperationStep(output.operationSteps, context)
            : undefined,
        OperationType: (0, smithy_client_1.expectString)(output.operationType),
        SourceClusterInfo: output.sourceClusterInfo !== undefined && output.sourceClusterInfo !== null
            ? deserializeAws_restJson1MutableClusterInfo(output.sourceClusterInfo, context)
            : undefined,
        TargetClusterInfo: output.targetClusterInfo !== undefined && output.targetClusterInfo !== null
            ? deserializeAws_restJson1MutableClusterInfo(output.targetClusterInfo, context)
            : undefined,
    };
};
const deserializeAws_restJson1ClusterOperationStep = (output, context) => {
    return {
        StepInfo: output.stepInfo !== undefined && output.stepInfo !== null
            ? deserializeAws_restJson1ClusterOperationStepInfo(output.stepInfo, context)
            : undefined,
        StepName: (0, smithy_client_1.expectString)(output.stepName),
    };
};
const deserializeAws_restJson1ClusterOperationStepInfo = (output, context) => {
    return {
        StepStatus: (0, smithy_client_1.expectString)(output.stepStatus),
    };
};
const deserializeAws_restJson1CompatibleKafkaVersion = (output, context) => {
    return {
        SourceVersion: (0, smithy_client_1.expectString)(output.sourceVersion),
        TargetVersions: output.targetVersions !== undefined && output.targetVersions !== null
            ? deserializeAws_restJson1__listOf__string(output.targetVersions, context)
            : undefined,
    };
};
const deserializeAws_restJson1Configuration = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.arn),
        CreationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(output.creationTime))
            : undefined,
        Description: (0, smithy_client_1.expectString)(output.description),
        KafkaVersions: output.kafkaVersions !== undefined && output.kafkaVersions !== null
            ? deserializeAws_restJson1__listOf__string(output.kafkaVersions, context)
            : undefined,
        LatestRevision: output.latestRevision !== undefined && output.latestRevision !== null
            ? deserializeAws_restJson1ConfigurationRevision(output.latestRevision, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.name),
        State: (0, smithy_client_1.expectString)(output.state),
    };
};
const deserializeAws_restJson1ConfigurationInfo = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.arn),
        Revision: (0, smithy_client_1.expectLong)(output.revision),
    };
};
const deserializeAws_restJson1ConfigurationRevision = (output, context) => {
    return {
        CreationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTime)(output.creationTime))
            : undefined,
        Description: (0, smithy_client_1.expectString)(output.description),
        Revision: (0, smithy_client_1.expectLong)(output.revision),
    };
};
const deserializeAws_restJson1ConnectivityInfo = (output, context) => {
    return {
        PublicAccess: output.publicAccess !== undefined && output.publicAccess !== null
            ? deserializeAws_restJson1PublicAccess(output.publicAccess, context)
            : undefined,
    };
};
const deserializeAws_restJson1EBSStorageInfo = (output, context) => {
    return {
        ProvisionedThroughput: output.provisionedThroughput !== undefined && output.provisionedThroughput !== null
            ? deserializeAws_restJson1ProvisionedThroughput(output.provisionedThroughput, context)
            : undefined,
        VolumeSize: (0, smithy_client_1.expectInt32)(output.volumeSize),
    };
};
const deserializeAws_restJson1EncryptionAtRest = (output, context) => {
    return {
        DataVolumeKMSKeyId: (0, smithy_client_1.expectString)(output.dataVolumeKMSKeyId),
    };
};
const deserializeAws_restJson1EncryptionInfo = (output, context) => {
    return {
        EncryptionAtRest: output.encryptionAtRest !== undefined && output.encryptionAtRest !== null
            ? deserializeAws_restJson1EncryptionAtRest(output.encryptionAtRest, context)
            : undefined,
        EncryptionInTransit: output.encryptionInTransit !== undefined && output.encryptionInTransit !== null
            ? deserializeAws_restJson1EncryptionInTransit(output.encryptionInTransit, context)
            : undefined,
    };
};
const deserializeAws_restJson1EncryptionInTransit = (output, context) => {
    return {
        ClientBroker: (0, smithy_client_1.expectString)(output.clientBroker),
        InCluster: (0, smithy_client_1.expectBoolean)(output.inCluster),
    };
};
const deserializeAws_restJson1ErrorInfo = (output, context) => {
    return {
        ErrorCode: (0, smithy_client_1.expectString)(output.errorCode),
        ErrorString: (0, smithy_client_1.expectString)(output.errorString),
    };
};
const deserializeAws_restJson1Firehose = (output, context) => {
    return {
        DeliveryStream: (0, smithy_client_1.expectString)(output.deliveryStream),
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
    };
};
const deserializeAws_restJson1Iam = (output, context) => {
    return {
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
    };
};
const deserializeAws_restJson1JmxExporter = (output, context) => {
    return {
        EnabledInBroker: (0, smithy_client_1.expectBoolean)(output.enabledInBroker),
    };
};
const deserializeAws_restJson1JmxExporterInfo = (output, context) => {
    return {
        EnabledInBroker: (0, smithy_client_1.expectBoolean)(output.enabledInBroker),
    };
};
const deserializeAws_restJson1KafkaVersion = (output, context) => {
    return {
        Status: (0, smithy_client_1.expectString)(output.status),
        Version: (0, smithy_client_1.expectString)(output.version),
    };
};
const deserializeAws_restJson1LoggingInfo = (output, context) => {
    return {
        BrokerLogs: output.brokerLogs !== undefined && output.brokerLogs !== null
            ? deserializeAws_restJson1BrokerLogs(output.brokerLogs, context)
            : undefined,
    };
};
const deserializeAws_restJson1MutableClusterInfo = (output, context) => {
    return {
        BrokerEBSVolumeInfo: output.brokerEBSVolumeInfo !== undefined && output.brokerEBSVolumeInfo !== null
            ? deserializeAws_restJson1__listOfBrokerEBSVolumeInfo(output.brokerEBSVolumeInfo, context)
            : undefined,
        ClientAuthentication: output.clientAuthentication !== undefined && output.clientAuthentication !== null
            ? deserializeAws_restJson1ClientAuthentication(output.clientAuthentication, context)
            : undefined,
        ConfigurationInfo: output.configurationInfo !== undefined && output.configurationInfo !== null
            ? deserializeAws_restJson1ConfigurationInfo(output.configurationInfo, context)
            : undefined,
        ConnectivityInfo: output.connectivityInfo !== undefined && output.connectivityInfo !== null
            ? deserializeAws_restJson1ConnectivityInfo(output.connectivityInfo, context)
            : undefined,
        EncryptionInfo: output.encryptionInfo !== undefined && output.encryptionInfo !== null
            ? deserializeAws_restJson1EncryptionInfo(output.encryptionInfo, context)
            : undefined,
        EnhancedMonitoring: (0, smithy_client_1.expectString)(output.enhancedMonitoring),
        InstanceType: (0, smithy_client_1.expectString)(output.instanceType),
        KafkaVersion: (0, smithy_client_1.expectString)(output.kafkaVersion),
        LoggingInfo: output.loggingInfo !== undefined && output.loggingInfo !== null
            ? deserializeAws_restJson1LoggingInfo(output.loggingInfo, context)
            : undefined,
        NumberOfBrokerNodes: (0, smithy_client_1.expectInt32)(output.numberOfBrokerNodes),
        OpenMonitoring: output.openMonitoring !== undefined && output.openMonitoring !== null
            ? deserializeAws_restJson1OpenMonitoring(output.openMonitoring, context)
            : undefined,
    };
};
const deserializeAws_restJson1NodeExporter = (output, context) => {
    return {
        EnabledInBroker: (0, smithy_client_1.expectBoolean)(output.enabledInBroker),
    };
};
const deserializeAws_restJson1NodeExporterInfo = (output, context) => {
    return {
        EnabledInBroker: (0, smithy_client_1.expectBoolean)(output.enabledInBroker),
    };
};
const deserializeAws_restJson1NodeInfo = (output, context) => {
    return {
        AddedToClusterTime: (0, smithy_client_1.expectString)(output.addedToClusterTime),
        BrokerNodeInfo: output.brokerNodeInfo !== undefined && output.brokerNodeInfo !== null
            ? deserializeAws_restJson1BrokerNodeInfo(output.brokerNodeInfo, context)
            : undefined,
        InstanceType: (0, smithy_client_1.expectString)(output.instanceType),
        NodeARN: (0, smithy_client_1.expectString)(output.nodeARN),
        NodeType: (0, smithy_client_1.expectString)(output.nodeType),
        ZookeeperNodeInfo: output.zookeeperNodeInfo !== undefined && output.zookeeperNodeInfo !== null
            ? deserializeAws_restJson1ZookeeperNodeInfo(output.zookeeperNodeInfo, context)
            : undefined,
    };
};
const deserializeAws_restJson1OpenMonitoring = (output, context) => {
    return {
        Prometheus: output.prometheus !== undefined && output.prometheus !== null
            ? deserializeAws_restJson1Prometheus(output.prometheus, context)
            : undefined,
    };
};
const deserializeAws_restJson1OpenMonitoringInfo = (output, context) => {
    return {
        Prometheus: output.prometheus !== undefined && output.prometheus !== null
            ? deserializeAws_restJson1PrometheusInfo(output.prometheus, context)
            : undefined,
    };
};
const deserializeAws_restJson1Prometheus = (output, context) => {
    return {
        JmxExporter: output.jmxExporter !== undefined && output.jmxExporter !== null
            ? deserializeAws_restJson1JmxExporter(output.jmxExporter, context)
            : undefined,
        NodeExporter: output.nodeExporter !== undefined && output.nodeExporter !== null
            ? deserializeAws_restJson1NodeExporter(output.nodeExporter, context)
            : undefined,
    };
};
const deserializeAws_restJson1PrometheusInfo = (output, context) => {
    return {
        JmxExporter: output.jmxExporter !== undefined && output.jmxExporter !== null
            ? deserializeAws_restJson1JmxExporterInfo(output.jmxExporter, context)
            : undefined,
        NodeExporter: output.nodeExporter !== undefined && output.nodeExporter !== null
            ? deserializeAws_restJson1NodeExporterInfo(output.nodeExporter, context)
            : undefined,
    };
};
const deserializeAws_restJson1Provisioned = (output, context) => {
    return {
        BrokerNodeGroupInfo: output.brokerNodeGroupInfo !== undefined && output.brokerNodeGroupInfo !== null
            ? deserializeAws_restJson1BrokerNodeGroupInfo(output.brokerNodeGroupInfo, context)
            : undefined,
        ClientAuthentication: output.clientAuthentication !== undefined && output.clientAuthentication !== null
            ? deserializeAws_restJson1ClientAuthentication(output.clientAuthentication, context)
            : undefined,
        CurrentBrokerSoftwareInfo: output.currentBrokerSoftwareInfo !== undefined && output.currentBrokerSoftwareInfo !== null
            ? deserializeAws_restJson1BrokerSoftwareInfo(output.currentBrokerSoftwareInfo, context)
            : undefined,
        EncryptionInfo: output.encryptionInfo !== undefined && output.encryptionInfo !== null
            ? deserializeAws_restJson1EncryptionInfo(output.encryptionInfo, context)
            : undefined,
        EnhancedMonitoring: (0, smithy_client_1.expectString)(output.enhancedMonitoring),
        LoggingInfo: output.loggingInfo !== undefined && output.loggingInfo !== null
            ? deserializeAws_restJson1LoggingInfo(output.loggingInfo, context)
            : undefined,
        NumberOfBrokerNodes: (0, smithy_client_1.expectInt32)(output.numberOfBrokerNodes),
        OpenMonitoring: output.openMonitoring !== undefined && output.openMonitoring !== null
            ? deserializeAws_restJson1OpenMonitoringInfo(output.openMonitoring, context)
            : undefined,
        ZookeeperConnectString: (0, smithy_client_1.expectString)(output.zookeeperConnectString),
        ZookeeperConnectStringTls: (0, smithy_client_1.expectString)(output.zookeeperConnectStringTls),
    };
};
const deserializeAws_restJson1ProvisionedThroughput = (output, context) => {
    return {
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
        VolumeThroughput: (0, smithy_client_1.expectInt32)(output.volumeThroughput),
    };
};
const deserializeAws_restJson1PublicAccess = (output, context) => {
    return {
        Type: (0, smithy_client_1.expectString)(output.type),
    };
};
const deserializeAws_restJson1S3 = (output, context) => {
    return {
        Bucket: (0, smithy_client_1.expectString)(output.bucket),
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
        Prefix: (0, smithy_client_1.expectString)(output.prefix),
    };
};
const deserializeAws_restJson1Sasl = (output, context) => {
    return {
        Iam: output.iam !== undefined && output.iam !== null ? deserializeAws_restJson1Iam(output.iam, context) : undefined,
        Scram: output.scram !== undefined && output.scram !== null
            ? deserializeAws_restJson1Scram(output.scram, context)
            : undefined,
    };
};
const deserializeAws_restJson1Scram = (output, context) => {
    return {
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
    };
};
const deserializeAws_restJson1Serverless = (output, context) => {
    return {
        ClientAuthentication: output.clientAuthentication !== undefined && output.clientAuthentication !== null
            ? deserializeAws_restJson1ServerlessClientAuthentication(output.clientAuthentication, context)
            : undefined,
        VpcConfigs: output.vpcConfigs !== undefined && output.vpcConfigs !== null
            ? deserializeAws_restJson1__listOfVpcConfig(output.vpcConfigs, context)
            : undefined,
    };
};
const deserializeAws_restJson1ServerlessClientAuthentication = (output, context) => {
    return {
        Sasl: output.sasl !== undefined && output.sasl !== null
            ? deserializeAws_restJson1ServerlessSasl(output.sasl, context)
            : undefined,
    };
};
const deserializeAws_restJson1ServerlessSasl = (output, context) => {
    return {
        Iam: output.iam !== undefined && output.iam !== null ? deserializeAws_restJson1Iam(output.iam, context) : undefined,
    };
};
const deserializeAws_restJson1StateInfo = (output, context) => {
    return {
        Code: (0, smithy_client_1.expectString)(output.code),
        Message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_restJson1StorageInfo = (output, context) => {
    return {
        EbsStorageInfo: output.ebsStorageInfo !== undefined && output.ebsStorageInfo !== null
            ? deserializeAws_restJson1EBSStorageInfo(output.ebsStorageInfo, context)
            : undefined,
    };
};
const deserializeAws_restJson1Tls = (output, context) => {
    return {
        CertificateAuthorityArnList: output.certificateAuthorityArnList !== undefined && output.certificateAuthorityArnList !== null
            ? deserializeAws_restJson1__listOf__string(output.certificateAuthorityArnList, context)
            : undefined,
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
    };
};
const deserializeAws_restJson1Unauthenticated = (output, context) => {
    return {
        Enabled: (0, smithy_client_1.expectBoolean)(output.enabled),
    };
};
const deserializeAws_restJson1UnprocessedScramSecret = (output, context) => {
    return {
        ErrorCode: (0, smithy_client_1.expectString)(output.errorCode),
        ErrorMessage: (0, smithy_client_1.expectString)(output.errorMessage),
        SecretArn: (0, smithy_client_1.expectString)(output.secretArn),
    };
};
const deserializeAws_restJson1VpcConfig = (output, context) => {
    return {
        SecurityGroupIds: output.securityGroupIds !== undefined && output.securityGroupIds !== null
            ? deserializeAws_restJson1__listOf__string(output.securityGroupIds, context)
            : undefined,
        SubnetIds: output.subnetIds !== undefined && output.subnetIds !== null
            ? deserializeAws_restJson1__listOf__string(output.subnetIds, context)
            : undefined,
    };
};
const deserializeAws_restJson1ZookeeperNodeInfo = (output, context) => {
    return {
        AttachedENIId: (0, smithy_client_1.expectString)(output.attachedENIId),
        ClientVpcIpAddress: (0, smithy_client_1.expectString)(output.clientVpcIpAddress),
        Endpoints: output.endpoints !== undefined && output.endpoints !== null
            ? deserializeAws_restJson1__listOf__string(output.endpoints, context)
            : undefined,
        ZookeeperId: (0, smithy_client_1.limitedParseDouble)(output.zookeeperId),
        ZookeeperVersion: (0, smithy_client_1.expectString)(output.zookeeperVersion),
    };
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
