import { __assign, __extends } from "tslib";
import { KafkaServiceException as __BaseException } from "./KafkaServiceException";
export var ProvisionedThroughput;
(function (ProvisionedThroughput) {
    ProvisionedThroughput.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ProvisionedThroughput || (ProvisionedThroughput = {}));
export var BrokerEBSVolumeInfo;
(function (BrokerEBSVolumeInfo) {
    BrokerEBSVolumeInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BrokerEBSVolumeInfo || (BrokerEBSVolumeInfo = {}));
export var ClusterType;
(function (ClusterType) {
    ClusterType["PROVISIONED"] = "PROVISIONED";
    ClusterType["SERVERLESS"] = "SERVERLESS";
})(ClusterType || (ClusterType = {}));
export var BrokerAZDistribution;
(function (BrokerAZDistribution) {
    BrokerAZDistribution["DEFAULT"] = "DEFAULT";
})(BrokerAZDistribution || (BrokerAZDistribution = {}));
export var PublicAccess;
(function (PublicAccess) {
    PublicAccess.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PublicAccess || (PublicAccess = {}));
export var ConnectivityInfo;
(function (ConnectivityInfo) {
    ConnectivityInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ConnectivityInfo || (ConnectivityInfo = {}));
export var EBSStorageInfo;
(function (EBSStorageInfo) {
    EBSStorageInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EBSStorageInfo || (EBSStorageInfo = {}));
export var StorageInfo;
(function (StorageInfo) {
    StorageInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(StorageInfo || (StorageInfo = {}));
export var BrokerNodeGroupInfo;
(function (BrokerNodeGroupInfo) {
    BrokerNodeGroupInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BrokerNodeGroupInfo || (BrokerNodeGroupInfo = {}));
export var Iam;
(function (Iam) {
    Iam.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Iam || (Iam = {}));
export var Scram;
(function (Scram) {
    Scram.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Scram || (Scram = {}));
export var Sasl;
(function (Sasl) {
    Sasl.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Sasl || (Sasl = {}));
export var Tls;
(function (Tls) {
    Tls.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Tls || (Tls = {}));
export var Unauthenticated;
(function (Unauthenticated) {
    Unauthenticated.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Unauthenticated || (Unauthenticated = {}));
export var ClientAuthentication;
(function (ClientAuthentication) {
    ClientAuthentication.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClientAuthentication || (ClientAuthentication = {}));
export var BrokerSoftwareInfo;
(function (BrokerSoftwareInfo) {
    BrokerSoftwareInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BrokerSoftwareInfo || (BrokerSoftwareInfo = {}));
export var EncryptionAtRest;
(function (EncryptionAtRest) {
    EncryptionAtRest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EncryptionAtRest || (EncryptionAtRest = {}));
export var ClientBroker;
(function (ClientBroker) {
    ClientBroker["PLAINTEXT"] = "PLAINTEXT";
    ClientBroker["TLS"] = "TLS";
    ClientBroker["TLS_PLAINTEXT"] = "TLS_PLAINTEXT";
})(ClientBroker || (ClientBroker = {}));
export var EncryptionInTransit;
(function (EncryptionInTransit) {
    EncryptionInTransit.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EncryptionInTransit || (EncryptionInTransit = {}));
export var EncryptionInfo;
(function (EncryptionInfo) {
    EncryptionInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EncryptionInfo || (EncryptionInfo = {}));
export var EnhancedMonitoring;
(function (EnhancedMonitoring) {
    EnhancedMonitoring["DEFAULT"] = "DEFAULT";
    EnhancedMonitoring["PER_BROKER"] = "PER_BROKER";
    EnhancedMonitoring["PER_TOPIC_PER_BROKER"] = "PER_TOPIC_PER_BROKER";
    EnhancedMonitoring["PER_TOPIC_PER_PARTITION"] = "PER_TOPIC_PER_PARTITION";
})(EnhancedMonitoring || (EnhancedMonitoring = {}));
export var CloudWatchLogs;
(function (CloudWatchLogs) {
    CloudWatchLogs.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CloudWatchLogs || (CloudWatchLogs = {}));
export var Firehose;
(function (Firehose) {
    Firehose.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Firehose || (Firehose = {}));
export var S3;
(function (S3) {
    S3.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3 || (S3 = {}));
export var BrokerLogs;
(function (BrokerLogs) {
    BrokerLogs.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BrokerLogs || (BrokerLogs = {}));
export var LoggingInfo;
(function (LoggingInfo) {
    LoggingInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(LoggingInfo || (LoggingInfo = {}));
export var JmxExporterInfo;
(function (JmxExporterInfo) {
    JmxExporterInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(JmxExporterInfo || (JmxExporterInfo = {}));
export var NodeExporterInfo;
(function (NodeExporterInfo) {
    NodeExporterInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(NodeExporterInfo || (NodeExporterInfo = {}));
export var PrometheusInfo;
(function (PrometheusInfo) {
    PrometheusInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PrometheusInfo || (PrometheusInfo = {}));
export var OpenMonitoringInfo;
(function (OpenMonitoringInfo) {
    OpenMonitoringInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(OpenMonitoringInfo || (OpenMonitoringInfo = {}));
export var Provisioned;
(function (Provisioned) {
    Provisioned.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Provisioned || (Provisioned = {}));
export var ServerlessSasl;
(function (ServerlessSasl) {
    ServerlessSasl.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ServerlessSasl || (ServerlessSasl = {}));
export var ServerlessClientAuthentication;
(function (ServerlessClientAuthentication) {
    ServerlessClientAuthentication.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ServerlessClientAuthentication || (ServerlessClientAuthentication = {}));
export var VpcConfig;
(function (VpcConfig) {
    VpcConfig.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(VpcConfig || (VpcConfig = {}));
export var Serverless;
(function (Serverless) {
    Serverless.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Serverless || (Serverless = {}));
export var ClusterState;
(function (ClusterState) {
    ClusterState["ACTIVE"] = "ACTIVE";
    ClusterState["CREATING"] = "CREATING";
    ClusterState["DELETING"] = "DELETING";
    ClusterState["FAILED"] = "FAILED";
    ClusterState["HEALING"] = "HEALING";
    ClusterState["MAINTENANCE"] = "MAINTENANCE";
    ClusterState["REBOOTING_BROKER"] = "REBOOTING_BROKER";
    ClusterState["UPDATING"] = "UPDATING";
})(ClusterState || (ClusterState = {}));
export var StateInfo;
(function (StateInfo) {
    StateInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(StateInfo || (StateInfo = {}));
export var Cluster;
(function (Cluster) {
    Cluster.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Cluster || (Cluster = {}));
export var JmxExporter;
(function (JmxExporter) {
    JmxExporter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(JmxExporter || (JmxExporter = {}));
export var NodeExporter;
(function (NodeExporter) {
    NodeExporter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(NodeExporter || (NodeExporter = {}));
export var Prometheus;
(function (Prometheus) {
    Prometheus.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Prometheus || (Prometheus = {}));
export var OpenMonitoring;
(function (OpenMonitoring) {
    OpenMonitoring.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(OpenMonitoring || (OpenMonitoring = {}));
export var ClusterInfo;
(function (ClusterInfo) {
    ClusterInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClusterInfo || (ClusterInfo = {}));
export var ErrorInfo;
(function (ErrorInfo) {
    ErrorInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ErrorInfo || (ErrorInfo = {}));
export var ClusterOperationStepInfo;
(function (ClusterOperationStepInfo) {
    ClusterOperationStepInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClusterOperationStepInfo || (ClusterOperationStepInfo = {}));
export var ClusterOperationStep;
(function (ClusterOperationStep) {
    ClusterOperationStep.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClusterOperationStep || (ClusterOperationStep = {}));
export var ConfigurationInfo;
(function (ConfigurationInfo) {
    ConfigurationInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ConfigurationInfo || (ConfigurationInfo = {}));
export var MutableClusterInfo;
(function (MutableClusterInfo) {
    MutableClusterInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(MutableClusterInfo || (MutableClusterInfo = {}));
export var ClusterOperationInfo;
(function (ClusterOperationInfo) {
    ClusterOperationInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClusterOperationInfo || (ClusterOperationInfo = {}));
export var CompatibleKafkaVersion;
(function (CompatibleKafkaVersion) {
    CompatibleKafkaVersion.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CompatibleKafkaVersion || (CompatibleKafkaVersion = {}));
export var ConfigurationRevision;
(function (ConfigurationRevision) {
    ConfigurationRevision.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ConfigurationRevision || (ConfigurationRevision = {}));
export var ConfigurationState;
(function (ConfigurationState) {
    ConfigurationState["ACTIVE"] = "ACTIVE";
    ConfigurationState["DELETE_FAILED"] = "DELETE_FAILED";
    ConfigurationState["DELETING"] = "DELETING";
})(ConfigurationState || (ConfigurationState = {}));
export var Configuration;
(function (Configuration) {
    Configuration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Configuration || (Configuration = {}));
export var KafkaVersionStatus;
(function (KafkaVersionStatus) {
    KafkaVersionStatus["ACTIVE"] = "ACTIVE";
    KafkaVersionStatus["DEPRECATED"] = "DEPRECATED";
})(KafkaVersionStatus || (KafkaVersionStatus = {}));
export var KafkaVersion;
(function (KafkaVersion) {
    KafkaVersion.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(KafkaVersion || (KafkaVersion = {}));
export var BrokerNodeInfo;
(function (BrokerNodeInfo) {
    BrokerNodeInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BrokerNodeInfo || (BrokerNodeInfo = {}));
export var NodeType;
(function (NodeType) {
    NodeType["BROKER"] = "BROKER";
})(NodeType || (NodeType = {}));
export var ZookeeperNodeInfo;
(function (ZookeeperNodeInfo) {
    ZookeeperNodeInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ZookeeperNodeInfo || (ZookeeperNodeInfo = {}));
export var NodeInfo;
(function (NodeInfo) {
    NodeInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(NodeInfo || (NodeInfo = {}));
export var UnprocessedScramSecret;
(function (UnprocessedScramSecret) {
    UnprocessedScramSecret.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UnprocessedScramSecret || (UnprocessedScramSecret = {}));
var BadRequestException = (function (_super) {
    __extends(BadRequestException, _super);
    function BadRequestException(opts) {
        var _this = _super.call(this, __assign({ name: "BadRequestException", $fault: "client" }, opts)) || this;
        _this.name = "BadRequestException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, BadRequestException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return BadRequestException;
}(__BaseException));
export { BadRequestException };
export var BatchAssociateScramSecretRequest;
(function (BatchAssociateScramSecretRequest) {
    BatchAssociateScramSecretRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BatchAssociateScramSecretRequest || (BatchAssociateScramSecretRequest = {}));
export var BatchAssociateScramSecretResponse;
(function (BatchAssociateScramSecretResponse) {
    BatchAssociateScramSecretResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BatchAssociateScramSecretResponse || (BatchAssociateScramSecretResponse = {}));
var ForbiddenException = (function (_super) {
    __extends(ForbiddenException, _super);
    function ForbiddenException(opts) {
        var _this = _super.call(this, __assign({ name: "ForbiddenException", $fault: "client" }, opts)) || this;
        _this.name = "ForbiddenException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ForbiddenException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return ForbiddenException;
}(__BaseException));
export { ForbiddenException };
var InternalServerErrorException = (function (_super) {
    __extends(InternalServerErrorException, _super);
    function InternalServerErrorException(opts) {
        var _this = _super.call(this, __assign({ name: "InternalServerErrorException", $fault: "server" }, opts)) || this;
        _this.name = "InternalServerErrorException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, InternalServerErrorException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return InternalServerErrorException;
}(__BaseException));
export { InternalServerErrorException };
var NotFoundException = (function (_super) {
    __extends(NotFoundException, _super);
    function NotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "NotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "NotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, NotFoundException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return NotFoundException;
}(__BaseException));
export { NotFoundException };
var ServiceUnavailableException = (function (_super) {
    __extends(ServiceUnavailableException, _super);
    function ServiceUnavailableException(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceUnavailableException", $fault: "server" }, opts)) || this;
        _this.name = "ServiceUnavailableException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, ServiceUnavailableException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return ServiceUnavailableException;
}(__BaseException));
export { ServiceUnavailableException };
var TooManyRequestsException = (function (_super) {
    __extends(TooManyRequestsException, _super);
    function TooManyRequestsException(opts) {
        var _this = _super.call(this, __assign({ name: "TooManyRequestsException", $fault: "client" }, opts)) || this;
        _this.name = "TooManyRequestsException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, TooManyRequestsException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return TooManyRequestsException;
}(__BaseException));
export { TooManyRequestsException };
var UnauthorizedException = (function (_super) {
    __extends(UnauthorizedException, _super);
    function UnauthorizedException(opts) {
        var _this = _super.call(this, __assign({ name: "UnauthorizedException", $fault: "client" }, opts)) || this;
        _this.name = "UnauthorizedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, UnauthorizedException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return UnauthorizedException;
}(__BaseException));
export { UnauthorizedException };
export var BatchDisassociateScramSecretRequest;
(function (BatchDisassociateScramSecretRequest) {
    BatchDisassociateScramSecretRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BatchDisassociateScramSecretRequest || (BatchDisassociateScramSecretRequest = {}));
export var BatchDisassociateScramSecretResponse;
(function (BatchDisassociateScramSecretResponse) {
    BatchDisassociateScramSecretResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BatchDisassociateScramSecretResponse || (BatchDisassociateScramSecretResponse = {}));
var ConflictException = (function (_super) {
    __extends(ConflictException, _super);
    function ConflictException(opts) {
        var _this = _super.call(this, __assign({ name: "ConflictException", $fault: "client" }, opts)) || this;
        _this.name = "ConflictException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConflictException.prototype);
        _this.InvalidParameter = opts.InvalidParameter;
        _this.Message = opts.Message;
        return _this;
    }
    return ConflictException;
}(__BaseException));
export { ConflictException };
export var CreateClusterRequest;
(function (CreateClusterRequest) {
    CreateClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateClusterRequest || (CreateClusterRequest = {}));
export var CreateClusterResponse;
(function (CreateClusterResponse) {
    CreateClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateClusterResponse || (CreateClusterResponse = {}));
export var ProvisionedRequest;
(function (ProvisionedRequest) {
    ProvisionedRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ProvisionedRequest || (ProvisionedRequest = {}));
export var ServerlessRequest;
(function (ServerlessRequest) {
    ServerlessRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ServerlessRequest || (ServerlessRequest = {}));
export var CreateClusterV2Request;
(function (CreateClusterV2Request) {
    CreateClusterV2Request.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateClusterV2Request || (CreateClusterV2Request = {}));
export var CreateClusterV2Response;
(function (CreateClusterV2Response) {
    CreateClusterV2Response.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateClusterV2Response || (CreateClusterV2Response = {}));
export var CreateConfigurationRequest;
(function (CreateConfigurationRequest) {
    CreateConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateConfigurationRequest || (CreateConfigurationRequest = {}));
export var CreateConfigurationResponse;
(function (CreateConfigurationResponse) {
    CreateConfigurationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateConfigurationResponse || (CreateConfigurationResponse = {}));
export var DeleteClusterRequest;
(function (DeleteClusterRequest) {
    DeleteClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteClusterRequest || (DeleteClusterRequest = {}));
export var DeleteClusterResponse;
(function (DeleteClusterResponse) {
    DeleteClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteClusterResponse || (DeleteClusterResponse = {}));
export var DeleteConfigurationRequest;
(function (DeleteConfigurationRequest) {
    DeleteConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteConfigurationRequest || (DeleteConfigurationRequest = {}));
export var DeleteConfigurationResponse;
(function (DeleteConfigurationResponse) {
    DeleteConfigurationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteConfigurationResponse || (DeleteConfigurationResponse = {}));
export var DescribeClusterRequest;
(function (DescribeClusterRequest) {
    DescribeClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClusterRequest || (DescribeClusterRequest = {}));
export var DescribeClusterResponse;
(function (DescribeClusterResponse) {
    DescribeClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClusterResponse || (DescribeClusterResponse = {}));
export var DescribeClusterOperationRequest;
(function (DescribeClusterOperationRequest) {
    DescribeClusterOperationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClusterOperationRequest || (DescribeClusterOperationRequest = {}));
export var DescribeClusterOperationResponse;
(function (DescribeClusterOperationResponse) {
    DescribeClusterOperationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClusterOperationResponse || (DescribeClusterOperationResponse = {}));
export var DescribeClusterV2Request;
(function (DescribeClusterV2Request) {
    DescribeClusterV2Request.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClusterV2Request || (DescribeClusterV2Request = {}));
export var DescribeClusterV2Response;
(function (DescribeClusterV2Response) {
    DescribeClusterV2Response.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClusterV2Response || (DescribeClusterV2Response = {}));
export var DescribeConfigurationRequest;
(function (DescribeConfigurationRequest) {
    DescribeConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeConfigurationRequest || (DescribeConfigurationRequest = {}));
export var DescribeConfigurationResponse;
(function (DescribeConfigurationResponse) {
    DescribeConfigurationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeConfigurationResponse || (DescribeConfigurationResponse = {}));
export var DescribeConfigurationRevisionRequest;
(function (DescribeConfigurationRevisionRequest) {
    DescribeConfigurationRevisionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeConfigurationRevisionRequest || (DescribeConfigurationRevisionRequest = {}));
export var DescribeConfigurationRevisionResponse;
(function (DescribeConfigurationRevisionResponse) {
    DescribeConfigurationRevisionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeConfigurationRevisionResponse || (DescribeConfigurationRevisionResponse = {}));
export var GetBootstrapBrokersRequest;
(function (GetBootstrapBrokersRequest) {
    GetBootstrapBrokersRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetBootstrapBrokersRequest || (GetBootstrapBrokersRequest = {}));
export var GetBootstrapBrokersResponse;
(function (GetBootstrapBrokersResponse) {
    GetBootstrapBrokersResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetBootstrapBrokersResponse || (GetBootstrapBrokersResponse = {}));
export var GetCompatibleKafkaVersionsRequest;
(function (GetCompatibleKafkaVersionsRequest) {
    GetCompatibleKafkaVersionsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetCompatibleKafkaVersionsRequest || (GetCompatibleKafkaVersionsRequest = {}));
export var GetCompatibleKafkaVersionsResponse;
(function (GetCompatibleKafkaVersionsResponse) {
    GetCompatibleKafkaVersionsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetCompatibleKafkaVersionsResponse || (GetCompatibleKafkaVersionsResponse = {}));
export var ListClusterOperationsRequest;
(function (ListClusterOperationsRequest) {
    ListClusterOperationsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListClusterOperationsRequest || (ListClusterOperationsRequest = {}));
export var ListClusterOperationsResponse;
(function (ListClusterOperationsResponse) {
    ListClusterOperationsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListClusterOperationsResponse || (ListClusterOperationsResponse = {}));
export var ListClustersRequest;
(function (ListClustersRequest) {
    ListClustersRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListClustersRequest || (ListClustersRequest = {}));
export var ListClustersResponse;
(function (ListClustersResponse) {
    ListClustersResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListClustersResponse || (ListClustersResponse = {}));
export var ListClustersV2Request;
(function (ListClustersV2Request) {
    ListClustersV2Request.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListClustersV2Request || (ListClustersV2Request = {}));
export var ListClustersV2Response;
(function (ListClustersV2Response) {
    ListClustersV2Response.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListClustersV2Response || (ListClustersV2Response = {}));
export var ListConfigurationRevisionsRequest;
(function (ListConfigurationRevisionsRequest) {
    ListConfigurationRevisionsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListConfigurationRevisionsRequest || (ListConfigurationRevisionsRequest = {}));
export var ListConfigurationRevisionsResponse;
(function (ListConfigurationRevisionsResponse) {
    ListConfigurationRevisionsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListConfigurationRevisionsResponse || (ListConfigurationRevisionsResponse = {}));
export var ListConfigurationsRequest;
(function (ListConfigurationsRequest) {
    ListConfigurationsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListConfigurationsRequest || (ListConfigurationsRequest = {}));
export var ListConfigurationsResponse;
(function (ListConfigurationsResponse) {
    ListConfigurationsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListConfigurationsResponse || (ListConfigurationsResponse = {}));
export var ListKafkaVersionsRequest;
(function (ListKafkaVersionsRequest) {
    ListKafkaVersionsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListKafkaVersionsRequest || (ListKafkaVersionsRequest = {}));
export var ListKafkaVersionsResponse;
(function (ListKafkaVersionsResponse) {
    ListKafkaVersionsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListKafkaVersionsResponse || (ListKafkaVersionsResponse = {}));
export var ListNodesRequest;
(function (ListNodesRequest) {
    ListNodesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListNodesRequest || (ListNodesRequest = {}));
export var ListNodesResponse;
(function (ListNodesResponse) {
    ListNodesResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListNodesResponse || (ListNodesResponse = {}));
export var ListScramSecretsRequest;
(function (ListScramSecretsRequest) {
    ListScramSecretsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListScramSecretsRequest || (ListScramSecretsRequest = {}));
export var ListScramSecretsResponse;
(function (ListScramSecretsResponse) {
    ListScramSecretsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListScramSecretsResponse || (ListScramSecretsResponse = {}));
export var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceRequest || (ListTagsForResourceRequest = {}));
export var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceResponse || (ListTagsForResourceResponse = {}));
export var RebootBrokerRequest;
(function (RebootBrokerRequest) {
    RebootBrokerRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RebootBrokerRequest || (RebootBrokerRequest = {}));
export var RebootBrokerResponse;
(function (RebootBrokerResponse) {
    RebootBrokerResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RebootBrokerResponse || (RebootBrokerResponse = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UpdateBrokerCountRequest;
(function (UpdateBrokerCountRequest) {
    UpdateBrokerCountRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateBrokerCountRequest || (UpdateBrokerCountRequest = {}));
export var UpdateBrokerCountResponse;
(function (UpdateBrokerCountResponse) {
    UpdateBrokerCountResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateBrokerCountResponse || (UpdateBrokerCountResponse = {}));
export var UpdateBrokerStorageRequest;
(function (UpdateBrokerStorageRequest) {
    UpdateBrokerStorageRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateBrokerStorageRequest || (UpdateBrokerStorageRequest = {}));
export var UpdateBrokerStorageResponse;
(function (UpdateBrokerStorageResponse) {
    UpdateBrokerStorageResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateBrokerStorageResponse || (UpdateBrokerStorageResponse = {}));
export var UpdateBrokerTypeRequest;
(function (UpdateBrokerTypeRequest) {
    UpdateBrokerTypeRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateBrokerTypeRequest || (UpdateBrokerTypeRequest = {}));
export var UpdateBrokerTypeResponse;
(function (UpdateBrokerTypeResponse) {
    UpdateBrokerTypeResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateBrokerTypeResponse || (UpdateBrokerTypeResponse = {}));
export var UpdateClusterConfigurationRequest;
(function (UpdateClusterConfigurationRequest) {
    UpdateClusterConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateClusterConfigurationRequest || (UpdateClusterConfigurationRequest = {}));
export var UpdateClusterConfigurationResponse;
(function (UpdateClusterConfigurationResponse) {
    UpdateClusterConfigurationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateClusterConfigurationResponse || (UpdateClusterConfigurationResponse = {}));
export var UpdateClusterKafkaVersionRequest;
(function (UpdateClusterKafkaVersionRequest) {
    UpdateClusterKafkaVersionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateClusterKafkaVersionRequest || (UpdateClusterKafkaVersionRequest = {}));
export var UpdateClusterKafkaVersionResponse;
(function (UpdateClusterKafkaVersionResponse) {
    UpdateClusterKafkaVersionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateClusterKafkaVersionResponse || (UpdateClusterKafkaVersionResponse = {}));
export var UpdateConfigurationRequest;
(function (UpdateConfigurationRequest) {
    UpdateConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateConfigurationRequest || (UpdateConfigurationRequest = {}));
export var UpdateConfigurationResponse;
(function (UpdateConfigurationResponse) {
    UpdateConfigurationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateConfigurationResponse || (UpdateConfigurationResponse = {}));
export var UpdateConnectivityRequest;
(function (UpdateConnectivityRequest) {
    UpdateConnectivityRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateConnectivityRequest || (UpdateConnectivityRequest = {}));
export var UpdateConnectivityResponse;
(function (UpdateConnectivityResponse) {
    UpdateConnectivityResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateConnectivityResponse || (UpdateConnectivityResponse = {}));
export var UpdateMonitoringRequest;
(function (UpdateMonitoringRequest) {
    UpdateMonitoringRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateMonitoringRequest || (UpdateMonitoringRequest = {}));
export var UpdateMonitoringResponse;
(function (UpdateMonitoringResponse) {
    UpdateMonitoringResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateMonitoringResponse || (UpdateMonitoringResponse = {}));
export var UpdateSecurityRequest;
(function (UpdateSecurityRequest) {
    UpdateSecurityRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateSecurityRequest || (UpdateSecurityRequest = {}));
export var UpdateSecurityResponse;
(function (UpdateSecurityResponse) {
    UpdateSecurityResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateSecurityResponse || (UpdateSecurityResponse = {}));
